// lcd lph
//**************************
//  ,   
//   
// --------------------------------
//  StartCd.narod.ru.   
///**************************

//--------------------
// !     asm("sleep"); !
//--------------------

#include "clock_lcd.h"
void str_mes_in_lcd(uint8_t x, uint8_t y);
void str_day_in_lcd(uint8_t x, uint8_t y);
void hh_mm_ss(uint8_t x, uint8_t y, uint8_t *prt ,uint8_t ss, uint8_t miganie_linii);
void tempir_in_bcd(signed int t,  unsigned char pin_wire, uint8_t x, uint8_t y);
void format_1(void);
void format_2(void);
void format_3(void);
void format_4(void);
void format_5(void);
void format_6(void);
void format_7(void);
void format_8(void);
void format_9(void);


//**************************************
ISR(SIG_OVERFLOW2)
{
 clock_++;
 if (clock_==128)
	{	   	 		  	   	  				   	
	clock_=0;
	hour[h_sek]++;
  	}
}

//--------------------------------------
static void port_init(void)
{
	PORTKEY=KEY;
	BUDIL_SIG_INIT;
	BUDIL_PIN_ON_3_INIT;
	BUDIL_PIN_ON_2_INIT;
	BUDIL_PIN_ON_1_INIT;
	DDR_T_STAT|=PINS_T_SAT;
	PORT_POWER_DETECT|=_power_;
	LCD_POWER_INIT;
}

//**************************************
static void timer2_init(void)
{
	TCCR2 = 0x00; 		  //stop
	ASSR  = (1<<AS2);	  //set async mode
	TCCR2 = 0x01; 		  //start
}
//**************************************
void timer1_init(void)
{
	TCCR1B = 0; //stop
	TCCR1A	= 0;
	DDR_OC1A  &=~ OC1A;	  //OC1A 
	PORT_OC1A &=~ OC1A;
}

void shim_true(void)
{
	DDR_OC1A |= OC1A;		//OC1A
	TCCR1B = 0; 			//stop
	TCCR1A = (1<<COM1A0);	//Toggle OC1A/OC1B on Compare Match //TCCR1B WGM12=1 CTC top-OCR1A
	TCCR1B=(1<<CS10)|(1<<WGM12);

}

static void init_devices(void)
{
	cli();
	port_init();
	timer1_init();
	MCUCR = 0x00;
	GICR  = 0x00;
	ACSR=BIT(ACD);
	TIMSK =(1<<TOIE2); //timer interrupt sources
	sei(); 
}

//**************************************
//   
static unsigned char EEPROM_READ(unsigned int uiAddress)
{
	while(EECR & (1<<EEWE));/*     */
	EEAR = uiAddress;/*    */
	EECR |= (1<<EERE);/*       EERE */
	return EEDR;/*      */
}

static void EEPROM_write(unsigned int uiAddress, unsigned char ucData)
{
	if ( EEPROM_READ(uiAddress)!=ucData){
		/*     */
		while(EECR & (1<<EEWE));
		cli();
		/*     */
		EEAR = uiAddress;
		EEDR = ucData;
		/*  . 1   EEMWE */
		EECR |= (1<<EEMWE);
		/*       EEWE */
		EECR |= (1<<EEWE);
		sei();
		}
}
//*********************************************
static void read_data_EEPROM(void)
{
unsigned char  *a, i;
unsigned int crc=0;
	a=(unsigned char *)&setup;
	for( i=EEPROM_ADR ; i<sizeof(setup)+EEPROM_ADR; i++, a++){
		*a=EEPROM_READ(i);
		if (i<sizeof(setup)-2){
			crc+=*a;
			}
		}
	if ( crc!=setup.crc ) eeprom_err=1;
}

static void EEPROM_save_parametr_all( void )
{
 unsigned char i, *p;
 
	if (time_flag & fl_eeprom_write)
	{
	time_flag&= ~fl_eeprom_write;
	setup.crc=eeprom_err=0;
	
	p=(unsigned char *) &setup;
	for(i=EEPROM_ADR; i<sizeof(setup)+EEPROM_ADR ; i++, p++){
		EEPROM_write( i, *p );
		if (i<sizeof(setup)-2)
			setup.crc+=*p;
		}
	}
}

//------------DALLAS------------------
void pullup_off(void){
	DDR_1wire&=~pwire0;
	DDR_1wire&=~pwire1;
	PORT_1wire&=~pwire0;
	PORT_1wire&=~pwire1;
}

unsigned char readbit(void){
unsigned char i;
	cli();
	DDR_1wire|=out_1wire;//line down

	asm("nop");
	asm("nop");//1.25us
	DDR_1wire&=~out_1wire;//line up through 1.25us
	_delay_us(12);
	i=PIN_1wire;
	sei();
	_delay_us(47);
	return i;
}


void readbyte(unsigned char *pw) {
unsigned char i,r,p;//, a;

pw[0]=pw[1]=0;
pullup_off();
for(i=0, r=1; i<8; i++){
	p=readbit();
	//for(a=0; a<kolvo_datchikov; a++)
	//	if ( p & BIT(a) ) *(pw0+a)|=r; else *(pw0+a)&=~r;
	if ( p & pwire0 ) pw[0]|=r; 
	if ( p & pwire1 ) pw[1]|=r; 
	r<<=1;	
	}
PORT_1wire|=power_suplly_1w;
DDR_1wire|=power_suplly_1w;
}

//------------------------------------------------
static void writebit0(void){
	cli();
	DDR_1wire|=out_1wire;
	_delay_us(60);
	DDR_1wire&=~out_1wire;
	sei();
}
//***********************************************
void writebit1(void){
	cli();
	DDR_1wire|=out_1wire;
	_delay_us(3);
	DDR_1wire&=~out_1wire;
	sei();
	_delay_us(57);
}
//***********************************************
void writebyte(unsigned char byte){
unsigned char i;
	pullup_off();
	for(i=0; i<8; i++){
		if (byte&BIT(0)) 
			writebit1();
			else
			writebit0();
		byte>>=1;
		}
	PORT_1wire|=power_suplly_1w;
	DDR_1wire|=power_suplly_1w;
}

void detectPresence(void){
unsigned char i;
	
	pullup_off();
	out_1wire=pwire0|pwire1;
	
	DDR_1wire|=pwire0;
	DDR_1wire|=pwire1;
	_delay_ms(0.48);//0.48
	
	cli();
	DDR_1wire&=~pwire0;
	DDR_1wire&=~pwire1;
	_delay_us(60);//60
	i=PIN_1wire;
	sei();
	
	if ( i & pwire0 ) out_1wire&=~pwire0;
	if ( i & pwire1 ) out_1wire&=~pwire1;

	if ( out_1wire == 0 ){
		count_com_1w=0; 
		data_ok|=data_temperature;
		return;
		}
	
	_delay_ms(0.42);//0.42
	i=PIN_1wire;
	if (!( i & pwire0 )) out_1wire&=~pwire0;
	if (!( i & pwire1 )) out_1wire&=~pwire1;
	
	if ( out_1wire == 0 ){
		count_com_1w=0; 
		data_ok|=data_temperature;
		return;
		}
			
	power_suplly_1w &= out_1wire;
	PORT_1wire|=power_suplly_1w;
	DDR_1wire|=power_suplly_1w;	
}

//****************************************
static void scratchpad_save(void){

	detectPresence();//  
	writebyte(0xCC);//SKIP ROM [CCh]
	writebyte(0x4E);//WRITE SCRATCHPAD [4Eh]
	writebyte(5);//	TH
	writebyte(5);//	TL
	writebyte(0x7F);//	Statys 12bit
		
	detectPresence();//   EEPROM
	writebyte(0xCC);//SKIP ROM [CCh]
	writebyte(0x48);//COPY SCRATCHPAD [48h]
	PORT_1wire|=power_suplly_1w;
	DDR_1wire|=power_suplly_1w;
}

//**************************************************
void format_t(unsigned char p){
int t_point;
	t_point=(unsigned int)(tempir_msb[p]<<8);//msb
	t_point|=tempir_lsb[p];//lsb;
	tempiratura[p]=( t_point*10/16 );// + setup.correct_ds[p];

}	
//**************************************************
static void izmerenie_t(void)
{
if ( !count_com_1w ){//
	count_com_1w++;
	power_suplly_1w=0;
	detectPresence();//  
	}
	else
	if ( count_com_1w==1 ){
		count_com_1w++;
	
		writebyte(0xCC);//SKIP ROM [CCh]
		writebyte(0xB4);//READ POWER SUPPLY [B4h]
		pullup_off();
		
		power_suplly_1w=readbit();//     
		power_suplly_1w=~power_suplly_1w;//    ,  
		power_suplly_1w &= out_1wire;//pwire0|pwire1;
		}
	else
	if ( count_com_1w==2 ){	// 
		count_com_1w++;
		detectPresence();//
		}
	else
	if ( count_com_1w==3 ){
		count_com_1w++;
		writebyte(0xCC);//SKIP ROM [CCh]
		writebyte(0x44);//CONVERT T [44h]
		time[wire1]=125;//1sek
		}
	else
	if ( count_com_1w==4 ){
		if (time[wire1]<-10) count_com_1w++;
		}
	else
	if ( count_com_1w==5 ){// 
		count_com_1w++;
		detectPresence();//
		}
	else
	if ( count_com_1w==6 ){
		count_com_1w++;
		writebyte(0xCC);//SKIP ROM [CCh]
		writebyte(0xBE);//READ SCRATCHPAD [BEh]
		}
	else
	if ( count_com_1w==7 ){
		count_com_1w=0;

		readbyte(tempir_lsb);//LSB   
		readbyte(tempir_msb);//MSB   
	
		//for(i=0; i<kolvo_datchikov; i++){
		//	format_t(i);
		//	}
		format_t(0);
		format_t(1);
		//--------------------------------------------------------
		if (tempiratura[ds0] <= setup.porog[0][0])	PORT_T_STAT |= PIN_T_STAT_1;
		else
		if (tempiratura[ds0] >= setup.porog[0][1])	PORT_T_STAT &= ~PIN_T_STAT_1;
		
		if (tempiratura[ds0] <= setup.porog[1][0])	PORT_T_STAT &= ~PIN_T_STAT_2;
		else
		if (tempiratura[ds0] >= setup.porog[1][1])	PORT_T_STAT |= PIN_T_STAT_2;
		//--------------------------------------------------------	
		if (tempiratura[ds1] <= setup.porog[2][0])	PORT_T_STAT |= PIN_T_STAT_3;
		else
		if (tempiratura[ds1] >= setup.porog[2][1])	PORT_T_STAT &= ~PIN_T_STAT_3;
		
		if (tempiratura[ds1] <= setup.porog[3][0])	PORT_T_STAT &= ~PIN_T_STAT_4;
		else
		if (tempiratura[ds1] >= setup.porog[3][1])	PORT_T_STAT |= PIN_T_STAT_4;
		//--------------------------------------------------------
		data_ok|=data_temperature;
		}
}
//*************** END 1 Wire ***************************************************

//*************************************************************

static void skankey (void){
	unsigned char key_lokal=17;
	
	key=key_lokal;

	if 		(KEY_F)	    	key_lokal=1;
	else if	(KEY_SET)		key_lokal=2;
	else if	(KEY_PLUS)		key_lokal=3;
	else if	(KEY_MINUS)		key_lokal=4;
	else 					key_lokal=17;
	
	if ( key_lokal!=17 )
	{
	anti_drebezg[0]++;
	if (anti_drebezg[0]==5)//35)
		{
		key=key_lokal;
			OCR1A=0x0400;
			shim_true();//
			time_flag|= fl_sig_butt ;//fl_sek_1_switch;
			time[note_but]=5;
			//}
		}
	if (anti_drebezg[0]==anti_drebezg[2]){	//anti_drebezg[0]  
		anti_drebezg[0]=0;					//anti_drebezg[1] -   
		anti_drebezg[1]++;					//anti_drebezg[2]    
		if (anti_drebezg[1]==3) anti_drebezg[2]=10;//55;
		}	
	time_in_regim=25;
	}
	else
	{
	anti_drebezg[0]=0;
	anti_drebezg[1]=0;
	anti_drebezg[2]=50;
	}
}


//**************************************
void inc_dec_var(unsigned char *var, unsigned char limit){
	if (PLUS){
		if ((*var)<limit)	(*var)++; 
		else *var=0;
		}
	if (MINUS){
		if (*var) (*var)--;
		else *var=limit;
		}
}
//**************************************

void inc_dec_porog(signed int *p){
		if (PLUS){
			if (*p<1250)	(*p)++; 
			else *p=0;
			}
		if (MINUS){
			if (*p>-550) (*p)--;
			else *p=0;
			}
}

//**************************************
void mask_next_regim(unsigned char next_F,unsigned char SET)
{
	if (F_)   {regim=next_F;lcd_instructions_set(clear_display);lcd_instructions_set(cursor_off);}
	if (SET_) {regim=SET;lcd_instructions_set(clear_display);}
	key=17;
}

void next_regim(void){
	if (PLUS) {
		if (regim<END_REGIM) 
		regim++;
		lcd_instructions_set(clear_display);
		} 
	if (MINUS) {
		if (regim>FIRST_REGIM)
		regim--;
		lcd_instructions_set(clear_display);
		} 
	p_index=0;
}

//**************************************
static void key_action(void)
{//mask_next_regim(  if (key F_), if (key SET_) )
unsigned char *p,i;
	

	
if (key!=17) data_out_disable=0; else
	if ( (regim<FIRST_REGIM) && (regim>9) )
		if (time[data_out]<0){	//     
			time[data_out]=47;
			static uint8_t curs=0;
			curs=!curs;
			if (curs) lcd_instructions_set(cursor_lines);
			else lcd_instructions_set(cursor_off);
			}
			

	if ( regim == 0 ){ 
		p_index=x_index=0;
		
		if ( F_ )
			if (signal==3)	 {signal=0; lcd_instructions_set(cursor_off); return;}// 
			
		uint8_t j=FIRST_REGIM;
		if (eeprom_err) j=REG_SBROS_N;	
		if ( !(time_flag & fl_power_save) ){
			mask_next_regim(j,0);
			}
		
		return;
		}
	
	if (regim==REG_BUDILNIK_ON){
		if ( F_ ){ //   
			regim=signal=0;
			BUDIL_SIG_OFF;
			lcd_instructions_set(clear_display);
			lcd_instructions_set(cursor_off);
			}
		if (( PLUS )||( MINUS )||( SET_ )){// 
			BUDIL_SIG_OFF;
			regim=0;
			if (signal>1){
				signal=3;
				time_signal=0xFF;
				budilnik_play_num=0;
				}
				else
				signal=0;
			lcd_instructions_set(clear_display);
			lcd_instructions_set(cursor_off);
			}
		return;
		}
	//----------------------------
	if (regim==REG_BUDILNIK){
		next_regim();
		mask_next_regim(0,r_budilnik);	
		return;
		}
	if (regim==r_budilnik) {
		inc_dec_var(&p_index, kol_vo_sig_bud+kol_vo_pin_bud-1);
		mask_next_regim( 0,r_budilnik+1);	
		lcd_set_address(4,0);
		return;
		}
	if (regim==r_budilnik+1) {//   - /
		uint8_t j=2;
		if ( p_index >= kol_vo_sig_bud ) j=1;
		inc_dec_var(&setup.budilnik[p_index][_sig], j );
		mask_next_regim(r_budilnik,r_budilnik+2);	
		lcd_set_address(9,0);
		return;
		}
	if (regim==r_budilnik+2) {//   - 
		inc_dec_var(&setup.budilnik[p_index][h_hour], 23);
		mask_next_regim(r_budilnik,r_budilnik+3);	
		lcd_set_address(12,0);
		return;
		}
	if (regim==r_budilnik+3) { //   
		inc_dec_var(&setup.budilnik[p_index][h_min], 59);
		mask_next_regim(r_budilnik,r_budilnik+4);	
		lcd_set_address(15,0);
		return;
		}
	if (regim==r_budilnik+4) { //   -  
		if (SET_) if (++x_index==7) 
		{	x_index=0; 
			regim=r_budilnik; 
			if (p_index>=kol_vo_sig_bud) 
			{	regim=r_budilnik+5;
			}
		}
		if (F_) {regim=r_budilnik;x_index=0; }
		if ((PLUS)||(MINUS)) setup.budilnik[p_index][h_day]^=_BV(x_index);
		lcd_set_address(x_index,1);
		return;
		}
	if (regim==r_budilnik+5) { //     - 
		inc_dec_var(&setup.bud_pin[p_index-kol_vo_sig_bud][h_hour], 23);
		mask_next_regim(r_budilnik,r_budilnik+7);	
		lcd_set_address(9,1);
		return;
		}
	if (regim==r_budilnik+7) { //     - 
		inc_dec_var(&setup.bud_pin[p_index-kol_vo_sig_bud][h_min], 59);
		mask_next_regim(r_budilnik,r_budilnik+8);	
		lcd_set_address(12,1);
		return;
		}	
	if (regim==r_budilnik+8) { //     - 
		inc_dec_var(&setup.bud_pin[p_index-kol_vo_sig_bud][h_sek], 59);
		mask_next_regim(r_budilnik,r_budilnik);	
		lcd_set_address(15,1);
		return;
		}	
	//----------clock-----------------
	if (regim==REG_CLOCK) {
		next_regim();
		mask_next_regim(0,r_clock);//	
		return;
		}
	if (regim==r_clock) {// 
		inc_dec_var(&hour[h_num],30);
		lcd_set_address(1,0);
		mask_next_regim(REG_CLOCK,r_clock+1);	
		return;
		}
	if (regim==r_clock+1) {// 
		inc_dec_var(&hour[h_month],11);
		lcd_set_address(4,0);
		mask_next_regim(REG_CLOCK,r_clock+2);	
		return;
		}
	if (regim==r_clock+2) {// 
		inc_dec_var(&hour[h_hour],23);
		lcd_set_address(9,0);
		mask_next_regim(REG_CLOCK,r_clock+3);	
		return;
		}
	if (regim==r_clock+3) {// 
		inc_dec_var(&hour[h_min],59);
		lcd_set_address(12,0);
		mask_next_regim(REG_CLOCK,r_clock+4);	
		return;
		}
	if (regim==r_clock+4) {// 
		if (MINUS){
		   if (hour[h_sek]>31) hour[h_min]++;
		   hour[h_sek]=0;
		   clock_=0;
		   }
		lcd_set_address(15,0);
		mask_next_regim(REG_CLOCK,r_clock+5);	
		return;
		}
	if (regim==r_clock+5) {//  
		inc_dec_var(&hour[h_day],7-1);
		lcd_set_address(5,1);
		mask_next_regim(REG_CLOCK,r_clock+6);	
		return;
		}
		
	if (regim==r_clock+6) {//  
	 	inc_dec_var(&setup.corr_flag, 1);
		lcd_set_address(9,1);
	 	mask_next_regim(REG_CLOCK,r_clock+7);
		return;
		}
	if (regim==r_clock+7) {//  
	 	inc_dec_var(&setup.correction,sizeof(corr_in_lcd)/2-1);
		lcd_set_address(13,1);
	 	mask_next_regim(REG_CLOCK,REG_CLOCK);
		return;
		}

	//--------------------------
	if (regim==REG_POROG) {//
		next_regim();
		mask_next_regim(0,r_porog);//	
		return;
		}
	if (regim==r_porog) {//  
		inc_dec_var(&p_index,sizeof(setup.porog)/4-1);
		lcd_set_address(6,0);
		mask_next_regim(REG_POROG,r_porog+1);	
		return;
		}
	if (regim==r_porog+1) {//   
		inc_dec_porog(&setup.porog[p_index][0]);
		lcd_set_address(7,1);
		mask_next_regim(r_porog,r_porog+2);
		return;
		}
	if (regim==r_porog+2) {//  
		inc_dec_porog(&setup.porog[p_index][1]);
		lcd_set_address(14,1);
		mask_next_regim(r_porog,r_porog);
		return;
		}

	//----------------SEE------------------------------
	if (regim==REG_YST_SEE){//122
		next_regim();
		mask_next_regim(0,r_yst_see);//_t_SEE_
		view_regim_state=0;
		return;
		}
	if (regim==r_yst_see) {//  
	 	inc_dec_var( &view_regim_state, Nreg_st/2-1);//
		lcd_set_address(2,0);
	 	mask_next_regim(0,r_yst_see+1);
		return;
		}	
	if (regim==r_yst_see+1) {//  
	 	inc_dec_var(&setup.regim_state_time[view_regim_state*2],Nreg_st/2-1);
		lcd_set_address(6,0);
	 	mask_next_regim(r_yst_see,r_yst_see+2);
		return;
		}	
	if (regim==r_yst_see+2) {//  
	 	inc_dec_var(&setup.regim_state_time[view_regim_state*2+1],99);
	 	mask_next_regim(r_yst_see,r_yst_see);
		lcd_set_address(14,0);
		return;
		}
	
	//=============ds18b20===============
	if (regim==REG_DS18B20) {//126
		next_regim();
		mask_next_regim(0,r_ds18b20);
		return; 
		}	
	if (regim==r_ds18b20) {
		mask_next_regim(REG_DS18B20,r_ds18b20+1); 
		if (regim==r_ds18b20+1) {
			scratchpad_save();		 
			regim=REG_DS18B20;
			}
		return;
		}
	
	//===========SBROC===================
	if (regim==REG_SBROS_N){//122
		next_regim();
		mask_next_regim(0,r_sbros_n);
		if (regim==0) lcd_instructions_set(clear_display);
		return;
		}	
	if (regim==r_sbros_n){
		lcd_set_address(17,0);
		mask_next_regim(REG_SBROS_N,r_sbros_n+1);
		if (regim==r_sbros_n+1){
			p=(unsigned char *) &setup;
			for(i=0; i<sizeof(setup) ; i++, p++)
				*p=0;
			lcd_instructions_set(clear_display);
			lcd_instructions_set(cursor_off);
			regim=0;
			}
		}
}


//****************************************
void result_in_bcd(int result)
{//0000 0000 0000 (1)0000  // (2)0000 (3)0000 (4)0000 (5)0000 hi2 hi3 low4 low5
    unsigned char dig_out=0;
	bcd_num0=0;
	bcd_num1=0;
	bcd_num2=0;
	bcd_num3=0;
	bcd_num4=0;
	while (result >= 10000) {
	 result -= 10000;
 	 dig_out ++;
	}
	bcd_num0=dig_out+0x30;
    dig_out = 0;
	while (result >= 1000) {
	 result -= 1000;
 	 dig_out ++;
	}
	bcd_num1=dig_out+0x30;
    dig_out = 0;
	while (result >= 100)  {
 	 result -= 100;
	 dig_out ++;
	 }
	bcd_num2=dig_out+0x30;
	dig_out = 0;
	while (result >= 10)   {
	 result -= 10;
	 dig_out ++;
	 }
	bcd_num3=dig_out+0x30;
	bcd_num4=result+0x30;
}
//**************************************
void num2_bcd_in_lcd(unsigned char param_out)
{
 	result_in_bcd(param_out);
	lcd_write_data(bcd_num3);
	lcd_write_data(bcd_num4);
}

void num1_bcd_in_lcd(unsigned char param_out)//     
{	unsigned char  n=' ';
	result_in_bcd(param_out);
	if ( bcd_num3!=0x30 ){ 
			n=bcd_num3; }
	lcd_write_data(n);
	lcd_write_data(bcd_num4);
}

//----------------------------------------------------------------


//**************************************
void tempir_in_bcd(signed int t,  unsigned char pin_wire, uint8_t x, uint8_t y){
unsigned char  znak=0, n1=' ',n2=' ';
		
	lcd_set_address(x,y);
	if ( !(pin_wire & out_1wire) ){
	 	lcd_write_data(' ');
		lcd_write_data('-');
		lcd_write_data('-');
		lcd_write_data('-');
		lcd_write_data(' ');
		}
		else
		{
		if ( t<0 ){
			znak=1;
			result_in_bcd( t * -1 );
			}
		else {
			result_in_bcd( t );
			}

		if ( bcd_num1!=0x30 ) {
			n1=bcd_num1;
			n2=bcd_num2;
			}
		else
		{
		if ( bcd_num2!=0x30 ){ 
			n2=bcd_num2; 
			if ( znak ) n1='-';
			else n1='+';
			}
			else
			if ( znak ) n2='-';
			else n2='+';
		}

		lcd_write_data(n1);
		lcd_write_data(n2);
		lcd_write_data(bcd_num3);
		lcd_write_data(',');
		lcd_write_data(bcd_num4);

		}
}

void str_day_in_lcd(uint8_t x, uint8_t y){		//   .  -  
	lcd_set_address(x,y);
	lcd_write_data(str_day[hour[h_day]][0]);
	lcd_write_data(str_day[hour[h_day]][1]);
}

void str_mes_in_lcd(uint8_t x, uint8_t y){		//   .  - 
	lcd_set_address(x,y);
	lcd_puts_p((prog_uint8_t *) &str_mes[hour[h_month]][0]);
	//lcd_write_data(str_mes[hour[h_month]][0]);
	//lcd_write_data(str_mes[hour[h_month]][1]);
	//lcd_write_data(str_mes[hour[h_month]][2]);
	//lcd_write_data(str_mes[hour[h_month]][3]);
}

void str_chislo_in_lcd(uint8_t x, uint8_t y){	//   . - 
	lcd_set_address(x,y);
	num1_bcd_in_lcd(hour[h_num]+1);
}

void load_str(uint8_t *str){

	for(; *str!='\0' ;){
		lcd_write_data(*(str++));
		}
	if (regim>=FIRST_REGIM) lcd_instructions_set(cursor_off);
}

//**************************************
static void view_in_indikator(unsigned char view){

	if 			(view==0)	format_1();
	else 	if 	(view==1)	format_2();
	else 	if 	(view==2)	format_3();
	else 	if 	(view==3)	format_4();
	else 	if 	(view==4)	format_5();
	else 	if 	(view==5)	format_6();
	else 	if 	(view==6)	format_7();
	else 	if 	(view==7)	format_8();
	else	format_9();//default*/
}

void indikator_manager(void){
unsigned char i, r;

r=viewstate;
i=view_regim_state;
if ( ++i>=(Nreg_st/2-1) ) i=0; //       .

	while(setup.regim_state_time[i*2+1] == 0 ){
		if ( i == view_regim_state) {
			time_view_buf=1;
			return;
			}
		if ( ++i>=(Nreg_st/2-1) ) i=0;
		}
	view_regim_state=i;
	time_view_buf=setup.regim_state_time[i*2+1];
	viewstate=setup.regim_state_time[i*2];
	if (r!=viewstate){//       
		lcd_set_address(0,0);
		for(i=0; i<16 ;i++) lcd_write_data(' ');
		}
}

void num_day(uint8_t x, uint8_t y){//   01.01
	lcd_set_address(x,y);
	num2_bcd_in_lcd(hour[h_num]+1);
	lcd_write_data('.');
	num2_bcd_in_lcd(hour[h_month]+1);
}

void hh_mm_ss(uint8_t x, uint8_t y, uint8_t *prt ,uint8_t ss, uint8_t miganie_linii){
	//  -, y-, *prt-(,..), ss==1 -   0-, miganie_linii 1- 
	lcd_set_address(x,y);
	num1_bcd_in_lcd(*(prt+2));//hour[h_hour]
	if (miganie_linii==0)
		lcd_write_data(':');
		else{
		if ( time_flag & fl_sek_1_switch )
			lcd_write_data(':'); else lcd_write_data(' ');
		}
	num2_bcd_in_lcd(*(prt+1));//hour[h_min]
	if (ss)
	{	lcd_write_data(':');
		num2_bcd_in_lcd(*prt);//hour[h_sek]
	}
}


//**************************************/
static void data_lcd(void)
{
	//   SETUP
	//      ,    
	//           . key_action()
	//  
	
	if ( data_out_disable ) return;
	data_out_disable=1;
	
	if (regim){
		viewstate=0;
		time_view_buf = 3;
		}
	
	///---------- -------------------------------------
	if (regim==REG_CLOCK){
		lcd_set_address(4,0);
		lcd_puts_p((prog_uint8_t *) str_ust);
		lcd_set_address(6,1);
		lcd_puts_p((prog_uint8_t *)str_clock);
		return;
	    } 
	if ( (regim >= r_clock ) && (regim <= r_clock+9) ) 
		{
		num_day(0,0);					// . 
		lcd_write_data(' ');
		hh_mm_ss(8,0,&hour[h_sek],1,0);// 
		
		lcd_set_address(0,1);
		lcd_puts_p((prog_uint8_t *)str_month);
		lcd_write_data('-');
		lcd_write_data(hour[h_day]+0x30+1);//  
		lcd_write_data(' ');
		lcd_write_data('k');
		lcd_write_data('.');
		
		if ( setup.corr_flag )	lcd_write_data('+'); else lcd_write_data('-');//   
		lcd_write_data(' ');
		result_in_bcd( pgm_read_word_near(&corr_in_lcd[setup.correction]) );// 
		lcd_write_data(bcd_num2);
		lcd_write_data(bcd_num3);
		lcd_write_data(bcd_num4);
		lcd_write_data('m');
		lcd_write_data('s');
		return;
		}
	
	//---------------------SET_View_LCD------------------------------------
	if (regim==REG_YST_SEE){
		lcd_set_address(4,0);
		lcd_puts_p((prog_uint8_t *) str_ust);
		lcd_set_address(6,1);
		lcd_puts_p((prog_uint8_t *)str_set_view);
		return;
	    }
	if ( (regim >= r_yst_see ) && (regim <= r_yst_see+2) ) 
		{
		lcd_set_address(0,0);
		lcd_write_data('R');
		lcd_write_data('-');
		lcd_write_data(view_regim_state+1+0x30);
		//lcd_write_data(' ');
		lcd_write_data(' ');
		lcd_write_data('F');
		lcd_write_data('-');
		lcd_write_data(setup.regim_state_time[view_regim_state*2] +1+0x30);
		lcd_write_data(' ');
		lcd_write_data('T');
		lcd_write_data('i');
		lcd_write_data('m');
		lcd_write_data('e');
		lcd_write_data('-');
		result_in_bcd( setup.regim_state_time[view_regim_state*2+1] );
		lcd_write_data(bcd_num3);
		lcd_write_data(bcd_num4);
		
		lcd_set_address(0,1);
		lcd_puts_p((prog_uint8_t *) &str_format[setup.regim_state_time[view_regim_state*2]][0]);

		return;
		}
	//-------------------DS18B20------------------------------
	if (regim==REG_DS18B20){
		lcd_set_address(4,0);
		lcd_puts_p((prog_uint8_t *)str_ds18b20);
		return;
		}
	if (regim==r_ds18b20){
		lcd_set_address(0,0);
		lcd_write_data('D');
		lcd_write_data('1');
		lcd_write_data('-');
		if ( !(pwire0 & out_1wire) ){
			lcd_write_data('H');
			lcd_write_data('E');
			lcd_write_data('T');
			}
			else
			if (power_suplly_1w & pwire0 )
			{
			lcd_write_data('P');
			lcd_write_data('a');
			lcd_write_data(' ');	
			}
			else{
			lcd_write_data('o');
			lcd_write_data('n');
			lcd_write_data(' ');
			}
		lcd_write_data(' ');
		lcd_write_data(' ');
		lcd_write_data('D');
		lcd_write_data('2');
		lcd_write_data('-');
		if ( !(pwire1 & out_1wire) ){
			lcd_write_data('H');
			lcd_write_data('E');
			lcd_write_data('T');
			}
			else
			if (power_suplly_1w & pwire1 )
			{
			lcd_write_data('P');
			lcd_write_data('a');
			lcd_write_data(' ');	
			}
			else{
			lcd_write_data('o');
			lcd_write_data('n');
			lcd_write_data(' ');
			}
		lcd_set_address(0,1);
		lcd_puts_p((prog_uint8_t *) str_press_set_to_12bit);
		
		return;
		}

	//-----------------------------------------
	if (regim==REG_BUDILNIK_ON){
		lcd_instructions_set(clear_display);
		lcd_puts_p((prog_uint8_t *) str_bud_on);
		lcd_write_data(budilnik_nomer+0x31);
		hh_mm_ss(5,1,&hour[h_sek],0,0);
		return;
		}
	if (regim==REG_BUDILNIK){
		lcd_set_address(4,0);
		lcd_puts_p((prog_uint8_t *) str_ust);
		lcd_set_address(3,1);
		lcd_puts_p((prog_uint8_t *)str_budil);
		return;
		}
	
	if ( (regim >= r_budilnik ) && (regim <= r_budilnik+9) ){
		//lcd_instructions_set(clear_display);
		lcd_set_address(0,0);
		if (p_index<kol_vo_sig_bud){
		lcd_write_data(0xA0);
		lcd_write_data(0x79);
		lcd_write_data(0xE3);
		lcd_write_data('.');
		lcd_write_data(0x30+p_index+1);
		lcd_write_data(' ');
		lcd_write_data(' ');
		}else{
		//	lcd_instructions_set(clear_display);
		lcd_write_data('P');
		lcd_write_data('i');
		lcd_write_data('n');
		lcd_write_data('.');
		lcd_write_data(0x30+p_index-kol_vo_sig_bud+1);
		lcd_write_data(' ');
		lcd_write_data(0x30+(p_index-kol_vo_sig_bud)/3+1);
		}
	
	
		if (setup.budilnik[p_index][_sig]==0){
		load_str((uint8_t *)str_off);
		}else
		if (setup.budilnik[p_index][_sig]==1){
		lcd_puts_p((prog_uint8_t *) str_on);
		}else
		lcd_puts_p((prog_uint8_t *) str_ots);
		
		hh_mm_ss(11, 0, &setup.budilnik[p_index][h_sek] ,0,0);
		
		lcd_set_address(0,1);
		for (uint8_t i=0; i<7; i++){
			if ( setup.budilnik[p_index][h_day] & BIT(i) )
			lcd_write_data(0x31+i); else lcd_write_data('_');
			}
		if (p_index>=kol_vo_sig_bud){
			hh_mm_ss(8, 1, &setup.bud_pin[p_index-kol_vo_sig_bud][h_sek] ,1,0);
			}
			else
			load_str((uint8_t *)str_blank);
			
		return;
		}

	//-----------------------------------------
	if (regim==REG_POROG) {//
		lcd_set_address(4,0);
		lcd_puts_p((prog_uint8_t *) str_ust);
		lcd_set_address(3,1);
		lcd_puts_p((prog_uint8_t *)str_tstat);
		return;
		}
	if ( (regim >= r_porog) && (regim <= r_porog+9) ){
		lcd_set_address(0,0);
		lcd_puts_p((prog_uint8_t *) str_nomer);
		lcd_write_data(' ');
		//lcd_write_data(' ');
		lcd_write_data(p_index+1+0x30);
		lcd_write_data(' ');
		//lcd_write_data(' ');
		
		if (p_index&_BV(0)){
		lcd_puts_p((prog_uint8_t *) str_off_on);
		}else{
		lcd_puts_p((prog_uint8_t *) str_on_off);
		}
		
		lcd_set_address(0,1);
		lcd_write_data('d');
		lcd_write_data(p_index/2+0x30+1);
		lcd_write_data(' ');
		uint8_t ds=pwire1;
		if ( p_index<2 ) ds=pwire0;
		
		tempir_in_bcd(setup.porog[p_index][0],ds,3,1);
		tempir_in_bcd(setup.porog[p_index][1],ds,10,1);
		}

	//------------------------------------------
	if (regim==REG_SBROS_N){
		lcd_set_address(5,0);
		lcd_puts_p((prog_uint8_t *)str_sbros);
		return;
		}
	if (regim==r_sbros_n){
		lcd_set_address(0,1);
		lcd_puts_p((prog_uint8_t *) str_sbros_aply);
		}

}

//**************************************
static void calls_verify(void)
{
unsigned char i;

	for(i=0;i<kol_vo_sig_bud+kol_vo_pin_bud;i++)
		if ( setup.budilnik[i][_sig] )//  
		  if ( setup.budilnik[i][h_day] & _BV(hour[h_day]) )//
			if (setup.budilnik[i][h_hour]==hour[h_hour])//
				if (setup.budilnik[i][h_min]==hour[h_min])//
				 {
					if (i<kol_vo_sig_bud)//  
					{
					BUDIL_SIG_ON;
					
					regim=REG_BUDILNIK_ON; 
					data_out_disable=0;
					time_signal=time_in_regim=59;
					signal=setup.budilnik[i][_sig];
					budilnik_nomer=i;
					budilnik_play_num=0;//           
					}else{// pin
					uint8_t c=(i-kol_vo_sig_bud)/3;
					budilnik_pin_on[c]=1;
					time_bud_pin[c]=(uint32_t)setup.bud_pin[i-kol_vo_sig_bud][h_hour]*3600;
					time_bud_pin[c]+=setup.bud_pin[i-kol_vo_sig_bud][h_min]*60;
					time_bud_pin[c]+=setup.bud_pin[i-kol_vo_sig_bud][h_sek];
					if (time_bud_pin[c])
						{
						if ( c==0 )
							BUDIL_PIN_ON_1;
						else
						if ( c==1 )
							BUDIL_PIN_ON_2;
						else
						if ( c==2 )
							BUDIL_PIN_ON_3;
						}
					}
				 }
}

void signal_verify(void){
	if (signal){
		if ( time_signal==0 ){
			BUDIL_SIG_OFF;
			if (signal==1) {//  
				signal=0;
				return;
				}
				else
			if (signal==2) {//  
				signal=3;
				time_signal=0xFF;
				}
				else
			if (signal==3) {
				if ( ++budilnik_play_num==7 ) signal=0;
				else{
					BUDIL_SIG_ON;
					regim=REG_BUDILNIK_ON; data_out_disable=0;
					time_signal=time_in_regim=59;
					signal=2;
					}
				}
			}
		
		}
}

void calls_pin_verify(void){

for (uint8_t i=0; i<3; i++)
{
	if (budilnik_pin_on[i])
	{
	if (--time_bud_pin[i]==0xFFFFFFFF)
		{
		budilnik_pin_on[i]=0;
		if ( i==0 )
			BUDIL_PIN_OFF_1;else
		if ( i==1 )
			BUDIL_PIN_OFF_2;else
		if ( i==2 )
			BUDIL_PIN_OFF_3;
		}
	}
}

}

//**************************************
static void clock(void){

 if (hour[h_sek]==60)
	{
   	hour[h_sek] =0;
	hour[h_min]++;
	if (hour[h_min]==60)
		{
		hour[h_min] =0;
		hour[h_hour]++;
		
		if ( setup.corr_flag )// 
   		   clock_+=setup.correction;// 
   		   else
   		   clock_= 0x00-setup.correction;
		
		if (hour[h_hour]==24)
			{
			hour[h_hour]=0;
			
			hour[h_day]++;
			hour[h_num]++;
			if (hour[h_day]>=7)	hour[h_day]=0;
			if (hour[h_num]>=num_in_month[ hour[h_month]] )
				{
				hour[h_num]=0;
				hour[h_month]++;
				if (hour[h_month]>=12) 	{hour[h_month]=0;}
				}
			}
		}
	calls_verify();
	}
 		
}

void time_direct(void){
static unsigned char t, sek;//, adc_usr;
unsigned char i;
	if ( t != clock_ )
		{//  0,0078125 .
		t=clock_;

		if (t==64) { //       0,5 
			time_flag^=fl_sek_1_switch;
			data_ok|=data_clock;//    
			}
		//*/
		for (i=0; i<4; i++) time[i]--;
		
		if ( time_flag & fl_sig_butt )
			if (time[note_but]<0)
			{
			timer1_init();
			time_flag&= ~ fl_sig_butt;
			}
		
		data_lcd();
		skankey();
		key_action();
		

		if (sek!=hour[h_sek]){// 
			sek=hour[h_sek];
			time_signal--;
			time_power_on--;
			
			if (regim==0)
			if (--time_view_buf == 0 ) indikator_manager();
			
			if (--time_in_regim==0)
				if (regim>=10) {regim=0; lcd_instructions_set(clear_display);lcd_instructions_set(cursor_off);}
			
			signal_verify();
			calls_pin_verify();
			
			if ( (regim >= r_clock ) && (regim <= r_clock+9) )  hh_mm_ss(8,0,&hour[h_sek],1,0);//      
			data_ok|=data_clock;// ,    
			}
		
		if (regim==0){
		//	format_1();
			if (!eeprom_err)
			view_in_indikator(viewstate);//  ,     
			else{
				time_view_buf=10;
				lcd_set_address(2,0);//   ,  error eeprom
				lcd_puts_p((prog_uint8_t *) str_eep);
				}
			}
		}
}

void temperature_str(void){//     
		
	if (data_ok & data_temperature){//   ()
		data_ok &= ~data_temperature;
		lcd_set_address(0,1);
		lcd_write_data(0xBA);
		tempir_in_bcd(tempiratura[0], pwire0,1,1);//  
		lcd_write_data(1);
		lcd_set_address(9,1);
		lcd_write_data(0x79);
		tempir_in_bcd(tempiratura[1], pwire1,10,1);
		lcd_write_data(1);
		}
}

void format_1(void){//{"12:00:00"}
	if (data_ok & data_clock){
		data_ok &= ~data_clock;
		hh_mm_ss(4,0,&hour[h_sek],1,0);
		}
	temperature_str();
}

void format_2(void){//{"12:00  p 01 "}
	if (data_ok & data_clock){
		data_ok &= ~data_clock;
		hh_mm_ss(0,0,&hour[h_sek],0,1);
		str_day_in_lcd(7,0);
		str_chislo_in_lcd(10,0);
		str_mes_in_lcd(13,0);
		
		}
	temperature_str();
}

void format_3(void){//{"12:00  01  Cp"}
	if (data_ok & data_clock){
		data_ok &= ~data_clock;
		hh_mm_ss(0,0,&hour[h_sek],0,1);
		str_chislo_in_lcd(7,0);
		str_mes_in_lcd(10,0);
		str_day_in_lcd(14,0);
		}
	temperature_str();
}

void format_4(void){//{"01  Cp  12:00"}
	if (data_ok & data_clock){
		data_ok &= ~data_clock;
		str_chislo_in_lcd(0,0);
		str_mes_in_lcd(3,0);
		str_day_in_lcd(7,0);
		hh_mm_ss(11,0,&hour[h_sek],0,1);
		}
	temperature_str();
}
void format_5(void){//{"Cp 01   12:00"}
	if (data_ok & data_clock){
		str_day_in_lcd(0,0);
		str_chislo_in_lcd(3,0);
		str_mes_in_lcd(6,0);
		hh_mm_ss(11,0,&hour[h_sek],0,1);
		}
	temperature_str();
}

void format_6(void){//{"01  12:00  "}
	if (data_ok & data_clock){
		data_ok &= ~data_clock;
		str_chislo_in_lcd(0,0);
		str_mes_in_lcd(3,0);
		hh_mm_ss(7,0,&hour[h_sek],0,1);
		str_day_in_lcd(14,0);
		
		
		}
	temperature_str();
}

void format_7(void){//{"12:00:00  CP "}
	if (data_ok & data_clock){
		data_ok &= ~data_clock;
		hh_mm_ss(2,0,&hour[h_sek],1,0);
		str_day_in_lcd(13,0);
		}
	temperature_str();
}

void format_8(void){//{"01.02    12:00  "}
	if (data_ok & data_clock){
		data_ok &= ~data_clock;
		num_day(0,0);
		hh_mm_ss(9,0,&hour[h_sek],0,1);
		}
	temperature_str();
}

void format_9(void){//{"12:00 CP 01.02 "}

if (data_ok & data_clock){
		data_ok &= ~data_clock;
		hh_mm_ss(0,0,&hour[h_sek],0,1);
		str_day_in_lcd(7,0);
		num_day(11,0);
		}
	temperature_str();
}



//**************************************
int main(void)
{
uint8_t power_on;	
	
	cli();
	//------------!!!  Fuse   JTAGEN  OCDEN !!!!
	MCUCSR=BIT(JTD);//jtag;
	MCUCSR=BIT(JTD);//jtag;
	
	read_data_EEPROM();
	timer2_init();
	init_devices();
	lcd_init();
	power_on=pin_power_;

while(1)
{//while
	/* */
	clock();

	if (power_on)
	{//begin power on
		if ( time_flag & fl_power_save)
		{	time_flag&= ~ fl_power_save;
			LCD_POWER_INIT;
			lcd_init();
			LCDdefinechar(grad, 0);
			LCDdefinechar(gradus, 1);					//     CGRAM
			//init_devices();
		}
		
		time_direct();
			
		izmerenie_t();	/* */
				
		//---------------
		if (regim>=10) {//  eeprom     
			time_flag|= fl_eeprom_write;
			time_power_on=15; //       !
			}
		if (regim==0)
			EEPROM_save_parametr_all();
			
		if (pin_power_){//   
			if (time_power_on<=0) //      
			if ( !(time_flag & fl_sig_butt) ){ //     
				power_on=0;//   
				pullup_off(); 
				LCD_POWER_OFF;
				DDRLCD=0xFF;
				PORT_T_STAT&=~PINS_T_SAT;
				}
			} 
			else {power_on=1; time_power_on=0;}// ,      
	  	
		if ( !(time_flag & fl_sig_butt) ){//        
			MCUCR = BIT(SM1)|BIT(SM0)|BIT(SE);
			asm("sleep");
			MCUCR=0;
			}	
		
	}//end power on
	else
	{//begin power off
	
	if	//((KEY_F)||(KEY_SET)||(!pin_power_)) {//       ,  .
		(!pin_power_){ //,   
		LCD_POWER_ON;
		time_flag|= fl_power_save;
		power_on=1;
		time_power_on=15; 
		time_view_buf=2;
		time_in_regim=2;
		regim=0;
		}
	else{
		MCUCR = BIT(SM1)|BIT(SM0)|BIT(SE);
		asm("sleep");
		MCUCR=0;
		}
	}//end power off

}//while

}


